/*fullscreen
static public void main(String args[]) {
  PApplet.main(new String[] { 
    "--display=1", "--present", "Teselador"                            }
  );
}
*/

void calcularNumeroDeTeselas(){
  numX = int((width)/(A/2))+1;
  numY = int((height)/(sqrt(3)*A/2))+1;
  teselas = new Tesela[numX*numY];
}

void crearTeselas(){
  for (int i = 0; i < teselas.length; i++){
    teselas[i] = new Tesela (A*0.95, -1000, -1000, false);
  }
}


void ubicarTeselas(){

  int c = 0;

  for (int y = 0; y < numY; y++){
    for(int x = 0; x < numX; x++){

      modY = y % 2;
      modX = x % 2;

      teselas[c].xpos = (A/2 * x);

      if (modY == 1){
        teselas[c].ypos = (sqrt(3)*A/2 * y) + (modX * sqrt(3) * A/6);
        if (modX == 1){
          teselas[c].parada = true;
        }
      }
      else{
        teselas[c].ypos = (sqrt(3)*A/2 * y) + (modX+1 * sqrt(3) * A/6);
        if (modX == 0){
          teselas[c].parada = true;
        }
        else{
          teselas[c].ypos -= sqrt(3)*A/6;
        }
      }
      c ++;
      if(c > teselas.length){
        break;
      }
    }
  }
}

void dibujarTeselas(){
  for (int i = 0; i < teselas.length; i++){
    teselas[i].dibujar();
  }
}

void agrandarTeselas(){
  for (int i = 0; i < teselas.length; i++){
    teselas[i].a ++;
  }
}

void achicarTeselas(){
  for (int i = 0; i < teselas.length; i++){
    teselas[i].a --;
  }
}

void agrandarEspacio(){
  A ++;
  ubicarTeselas();
}

void achicarEspacio(){
  if(teselas[0].a <= A){
    A --;
  }
  ubicarTeselas();
}

void todasMismoTipo(int tipo){
  for (int i = 0; i < teselas.length; i++){
    teselas[i].tipo = tipo;
  }
}

void todasTipoCualquiera(){
  for (int i = 0; i < teselas.length; i++){
    teselas[i].tipo = int(random(7))+1;
  }
}

void todasGiran(){
  for (int i = 0; i < teselas.length; i++){
    if(!teselas[i].girando){
      teselas[i].rotTarget = teselas[i].rot + TWO_PI/3 * float(int(random(2))+1);
      teselas[i].girando = true;
    }
  }
}

void mousePressed(){
  if (mouseButton == LEFT) {
    for (int i = 0; i < teselas.length; i++){
      if (teselas[i].sobre && !teselas[i].girando){
        teselas[i].rotTarget = teselas[i].rot + TWO_PI/3; //defino el destino de giro
        teselas[i].girando = true;
      }
    }
  }

  if(mouseButton == RIGHT){
    for (int i = 0; i < teselas.length; i++){
      if (teselas[i].sobre && !teselas[i].girando){
        teselas[i].tipo ++;
        if(teselas[i].tipo > 7){ 
          teselas[i].tipo = 1;
        }
      }
    }
  }
}
